﻿namespace SafeCampus.Application.Services.Business.AttendanceService;

public interface IAttendanceService:ITransient
{
    /// <summary>
    /// 添加考勤记录
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task<bool> Add(AttendanceDto input);
    /// <summary>
    /// 分页获取考勤列表
    /// </summary>
    /// <param name="search"></param>
    /// <returns></returns>
    Task<SqlSugarPagedList<AttendanceList>> GetPageList(AttendanceSearch search);
    /// <summary>
    /// 不分页获取考勤列表
    /// </summary>
    /// <param name="search"></param>
    /// <returns></returns>
    Task<List<AttendanceList>> GetNoPageList(AttendanceSearch search);
    /// <summary>
    /// 根据寝室id和归寝时间获取宿舍楼的出入记录
    /// </summary>
    /// <param name="id"></param>
    /// <param name="returnTime"></param>
    /// <returns></returns>
    Task<SqlSugarPagedList<AttendanceList>> GetPageListByBuild(BuildAttendanceSearch search);
}